Index: romio/adio/ad_pvfs2/ad_pvfs2_write.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/ad_pvfs2_write.c,v
retrieving revision 1.11
retrieving revision 1.13
--- romio/adio/ad_pvfs2/ad_pvfs2_write.c	5 Sep 2003 20:47:47 -0000	1.11
+++ romio/adio/ad_pvfs2/ad_pvfs2_write.c	20 May 2004 20:31:05 -0000	1.13
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- 
  *   vim: ts=8 sts=4 sw=4 noexpandtab
- *   $Id: ad_pvfs2_write.c,v 1.11 2003/09/05 20:47:47 robl Exp $
+ *   $Id: ad_pvfs2_write.c,v 1.13 2004/05/20 20:31:05 robl Exp $
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs2.h"
 #include "adio_extern.h"
 
@@ -33,26 +33,26 @@
 
     ret = PVFS_Request_contiguous(len, PVFS_BYTE, &file_req);
     if (ret < 0) {
 	fprintf(stderr, "pvfs_request_contig returns with %d\n", ret);
 	goto error_request;
     }
 
     if (file_ptr_type == ADIO_EXPLICIT_OFFSET) {
-	ret = PVFS_sys_write(pvfs_fs->pinode_refn, file_req, offset,  buf, 
-		mem_req, pvfs_fs->credentials, &resp_io);
+	ret = PVFS_sys_write(pvfs_fs->object_ref, file_req, offset,  buf, 
+		mem_req, &(pvfs_fs->credentials), &resp_io);
 	if (ret < 0 ) {
 	    fprintf(stderr, "pvfs_sys_write returns with %d\n", ret);
 	    goto error_write;
 	}
 	fd->fp_sys_posn = offset + (int) resp_io.total_completed;
     } else {
-	ret = PVFS_sys_write(pvfs_fs->pinode_refn, file_req, fd->fp_ind, buf, 
-		mem_req, pvfs_fs->credentials, &resp_io);
+	ret = PVFS_sys_write(pvfs_fs->object_ref, file_req, fd->fp_ind, buf, 
+		mem_req, &(pvfs_fs->credentials), &resp_io);
 	if (ret < 0) {
 	    fprintf(stderr, "pvfs_sys_write returns with %d\n", ret);
 	    goto error_write;
 	}
 	fd->fp_ind += (int)resp_io.total_completed;
 	fd->fp_sys_posn = fd->fp_ind;
     }
 #ifdef HAVE_STATUS_SET_BYTES
@@ -200,19 +200,19 @@
 		    }
 
 		    err_flag = PVFS_Request_hindexed(mem_list_count, 
 			    mem_lengths, mem_offsets, PVFS_BYTE, &mem_req);
 		    if (err_flag < 0) break;
 		    err_flag = PVFS_Request_contiguous(file_lengths, 
 			    PVFS_BYTE, &file_req);
 		    if (err_flag < 0) break;
-		    err_flag = PVFS_sys_write(pvfs_fs->pinode_refn, file_req, 
+		    err_flag = PVFS_sys_write(pvfs_fs->object_ref, file_req, 
 			    file_offsets, PVFS_BOTTOM, mem_req, 
-			    pvfs_fs->credentials, &resp_io);
+			    &(pvfs_fs->credentials), &resp_io);
 		  
 		    /* in the case of error or the last read list call, 
 		     * leave here */
 		    if (err_flag || b_blks_wrote == total_blks_to_write) break;
 
 		    file_offsets += file_lengths;
 		    file_lengths = 0;
 		} 
@@ -380,18 +380,18 @@
 		goto error_state;
 	    err_flag = PVFS_Request_hindexed(file_list_count, file_lengths, 
 		    file_offsets, PVFS_BYTE, &file_req);
 	    if (err_flag < 0)
 		goto error_state;
 	    /* PVFS_Request_hindexed already expresses the offsets into the
 	     * file, so we should not pass in an offset if we are using
 	     * hindexed for the file type */
-	    err_flag = PVFS_sys_write(pvfs_fs->pinode_refn, file_req, 0, 
-		    mem_offsets, mem_req, pvfs_fs->credentials, &resp_io);
+	    err_flag = PVFS_sys_write(pvfs_fs->object_ref, file_req, 0, 
+		    mem_offsets, mem_req, &(pvfs_fs->credentials), &resp_io);
 	    if (err_flag < 0)
 		goto error_state;
 
             mem_offsets += mem_lengths;
             mem_lengths = 0;
         } /* for (i=0; i<n_write_lists; i++) */
 
         /* for file arrays smaller than MAX_ARRAY_SIZE (last read_list call) */
@@ -422,18 +422,18 @@
 		    PVFS_BYTE, &mem_req);
 	    if (err_flag < 0)
 		goto error_state;
 	    err_flag = PVFS_Request_hindexed(file_list_count, file_lengths, 
 		    file_offsets, PVFS_BYTE, &file_req);
 	    if (err_flag < 0)
 		goto error_state;
 	    /* as above, use 0 for 'offset' when using hindexed file type*/
-	    err_flag = PVFS_sys_write(pvfs_fs->pinode_refn, file_req, 0, 
-		    mem_offsets, mem_req, pvfs_fs->credentials, &resp_io);
+	    err_flag = PVFS_sys_write(pvfs_fs->object_ref, file_req, 0, 
+		    mem_offsets, mem_req, &(pvfs_fs->credentials), &resp_io);
 	    if (err_flag < 0)
 		goto error_state;
         }
     } 
     else {
         /* noncontiguous in memory as well as in file */
 
         ADIOI_Flatten_datatype(datatype);
@@ -776,18 +776,18 @@
 		    mem_offsets, PVFS_BYTE, &mem_req);
 	    if (err_flag < 0 ) 
 		goto error_state;
 	    err_flag = PVFS_Request_hindexed(file_list_count, file_lengths, 
 		    file_offsets, PVFS_BYTE, &file_req);
 	    if (err_flag < 0)
 		goto error_state;
 	    /* offset will be expressed in memory and file datatypes */
-	    err_flag = PVFS_sys_write(pvfs_fs->pinode_refn, file_req, 0, 
-		    PVFS_BOTTOM, mem_req, pvfs_fs->credentials, &resp_io);
+	    err_flag = PVFS_sys_write(pvfs_fs->object_ref, file_req, 0, 
+		    PVFS_BOTTOM, mem_req, &(pvfs_fs->credentials), &resp_io);
 	    size_wrote += new_buffer_write;
 	    start_k = k;
 	    start_j = j;
 	} /* while (size_wrote < bufsize) */
 	ADIOI_Free(mem_offsets);
 	ADIOI_Free(mem_lengths);
     }
     ADIOI_Free(file_offsets);
Index: romio/adio/ad_sfs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_sfs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_sfs/.cvsignore	1 Aug 2003 13:30:18 -0000	1.2
+++ romio/adio/ad_sfs/.cvsignore	19 Jan 2004 14:49:36 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_testfs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_testfs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_testfs/.cvsignore	1 Aug 2003 13:30:19 -0000	1.2
+++ romio/adio/ad_testfs/.cvsignore	19 Jan 2004 14:49:36 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_ufs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_ufs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_ufs/.cvsignore	1 Aug 2003 13:30:19 -0000	1.2
+++ romio/adio/ad_ufs/.cvsignore	19 Jan 2004 14:49:37 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_xfs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_xfs/.cvsignore,v
retrieving revision 1.3
retrieving revision 1.4
--- romio/adio/ad_xfs/.cvsignore	1 Aug 2003 13:30:19 -0000	1.3
+++ romio/adio/ad_xfs/.cvsignore	19 Jan 2004 14:49:37 -0000	1.4
@@ -1,4 +1,5 @@
 Makefile
 *.safe
-
 .deps
+*.bb
+*.bbg
Index: romio/adio/common/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/common/.cvsignore,v
retrieving revision 1.3
retrieving revision 1.4
--- romio/adio/common/.cvsignore	1 Aug 2003 13:30:19 -0000	1.3
+++ romio/adio/common/.cvsignore	19 Jan 2004 14:49:37 -0000	1.4
@@ -1,5 +1,6 @@
 Makefile
 Debug*
 Release*
-
 .deps
+*.bb
+*.bbg
Index: romio/adio/common/ad_open.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/common/ad_open.c,v
retrieving revision 1.23
retrieving revision 1.27
--- romio/adio/common/ad_open.c	5 Sep 2003 22:35:49 -0000	1.23
+++ romio/adio/common/ad_open.c	20 May 2004 07:43:36 -0000	1.27
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_open.c,v 1.23 2003/09/05 22:35:49 gropp Exp $    
+ *   $Id: ad_open.c,v 1.27 2004/05/20 07:43:36 David Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "adio.h"
 #include "adio_extern.h"
 #include "adio_cb_config_list.h"
@@ -24,17 +24,17 @@
     ADIO_File fd;
     ADIO_cb_name_array array;
     int orig_amode_excl, orig_amode_wronly, err, rank, procs, agg_rank;
     char *value;
 #if defined(MPICH2) || !defined(PRINT_ERR_MSG)
     static char myname[] = "ADIO_OPEN";
 #endif
 
-    int rank_ct;
+    int rank_ct, max_error_code;
     int *tmp_ranklist;
     MPI_Comm aggregator_comm = MPI_COMM_NULL; /* just for deferred opens */
 
     *error_code = MPI_SUCCESS;
 
     fd = (ADIO_File) ADIOI_Malloc(sizeof(struct ADIOI_FileD));
     if (fd == NULL) {
 	/* NEED TO HANDLE ENOMEM ERRORS */
@@ -121,17 +121,17 @@
 	*error_code = MPI_ERR_UNKNOWN;
 #else
 	*error_code = MPIR_Err_setmsg(MPI_ERR_IO, MPIR_ADIO_ERROR, myname,
 				      "Open Error", "%s", 
 				      "No aggregators match");
 	ADIOI_Error(MPI_FILE_NULL, *error_code, myname);
 #endif
 	fd = ADIO_FILE_NULL;
-	return fd;
+        goto fn_exit;
     }
 
     /* deferred open: 
      * we can only do this if 'fd->hints->deferred_open' is set (which means
      * the user hinted 'no_indep_rw' and collective buffering).  Furthermore,
      * we only do this if our collective read/write routines use our generic
      * function, and not an fs-specific routine (we can defer opens only if we
      * use our aggreagation code). 
@@ -148,24 +148,28 @@
 	    /* MPI_Comm_split will create a communication group of aggregators.
 	     * for non-aggregators it will return MPI_COMM_NULL .  we rely on
 	     * fd->agg_comm == MPI_COMM_NULL for non-aggregators in several
 	     * tests in the code  */
 	    if (is_aggregator(rank, fd)) {
 		    MPI_Comm_split(fd->comm, 1, 0, &aggregator_comm);
 		    fd->agg_comm = aggregator_comm;
 		    MPI_Comm_rank(fd->agg_comm, &agg_rank);
-		    if (agg_rank == 0) fd->io_worker = 1;
+		    if (agg_rank == 0) {
+			    fd->io_worker = 1;
+		    }
 	    } else {
 		    MPI_Comm_split(fd->comm, MPI_UNDEFINED, 0, &aggregator_comm);
 		    fd->agg_comm = aggregator_comm;
 	    }
 
     } else {
-	    if (rank == 0) fd->io_worker = 1;
+	    if (rank == 0) {
+		    fd->io_worker = 1;
+	    }
     }
 
     orig_amode_excl = access_mode;
 
     /* we used to do this EXCL|CREAT workaround in MPI_File_open, but if we are
      * doing deferred open, we more easily know who the aggregators are in
      * ADIO_Open */
     if ((access_mode & MPI_MODE_CREATE) && (access_mode & MPI_MODE_EXCL)) {
@@ -179,24 +183,17 @@
 		MPI_Bcast(error_code, 1, MPI_INT, 0, fd->comm);
 		/* if no error, close the file and reopen normally below */
 		if (*error_code == MPI_SUCCESS) 
 			(*(fd->fns->ADIOI_xxx_Close))(fd, error_code);
        }
        else MPI_Bcast(error_code, 1, MPI_INT, 0, fd->comm);
 
        if (*error_code != MPI_SUCCESS) {
-	       /* copied from below */
-	       ADIOI_Free(fd->fns);
-	       MPI_Comm_free(&(fd->comm));
-	       free(fd->filename);
-	       MPI_Info_free(&(fd->info));
-	       ADIOI_Free(fd);
-	       fd = ADIO_FILE_NULL;
-	       return fd;
+           goto fn_exit;
        } 
        else {
 	       /* turn off EXCL for real open */
 	       access_mode = access_mode ^ MPI_MODE_EXCL; 
        }
     }
 
     /* if we are doing deferred open, non-aggregators should return now */
@@ -204,17 +201,17 @@
 		    ADIOI_Uses_generic_read(fd) &&
 		    ADIOI_Uses_generic_write(fd) ) {
 	    if (fd->agg_comm == MPI_COMM_NULL) {
 		    /* we might have turned off EXCL for the aggregators.
 		     * restore access_mode that non-aggregators get the right
 		     * value from get_amode */
 		    fd->access_mode = orig_amode_excl;
 		    *error_code = MPI_SUCCESS;
-		    return fd;
+            goto fn_exit;
 	    }
     }
 
 /* For writing with data sieving, a read-modify-write is needed. If 
    the file is opened for write_only, the read will fail. Therefore,
    if write_only, open the file as read_write, but record it as write_only
    in fd, so that get_amode returns the right answer. */
 
@@ -235,24 +232,55 @@
 
     /* if we turned off EXCL earlier, then we should turn it back on */
     if (fd->access_mode != orig_amode_excl) fd->access_mode = orig_amode_excl;
 
     /* for deferred open: this process has opened the file (because if we are
      * not an aggregaor and we are doing deferred open, we returned earlier)*/
     fd->is_open = 1;
 
-    /* if error, free and set fd to NULL */
-    if (*error_code != MPI_SUCCESS) {
-	ADIOI_Free(fd->fns);
-	MPI_Comm_free(&(fd->comm));
-	free(fd->filename);
-	MPI_Info_free(&(fd->info));
+ fn_exit:
+    MPI_Allreduce(error_code, &max_error_code, 1, MPI_INT, MPI_MAX, comm);
+    if (max_error_code != MPI_SUCCESS) {
+
+        /* If the file was successfully opened, close it */
+        if (*error_code == MPI_SUCCESS) {
+        
+            /* in the deferred open case, only those who have actually
+               opened the file should close it */
+            if (fd->hints->deferred_open && 
+                ADIOI_Uses_generic_read(fd) &&
+                ADIOI_Uses_generic_write(fd) ) {
+                if (fd->agg_comm != MPI_COMM_NULL) {
+                    (*(fd->fns->ADIOI_xxx_Close))(fd, error_code);
+                }
+            }
+            else {
+                (*(fd->fns->ADIOI_xxx_Close))(fd, error_code);
+            }
+        }
+
+	if (fd->fns) ADIOI_Free(fd->fns);
+	if (fd->filename) free(fd->filename);
+	if (fd->info != MPI_INFO_NULL) MPI_Info_free(&(fd->info));
 	ADIOI_Free(fd);
 	fd = ADIO_FILE_NULL;
+	if (*error_code == MPI_SUCCESS)
+	{
+#ifdef MPICH2
+	    *error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_IO, "**oremote_fail", 0);
+#elif defined(PRINT_ERR_MSG)
+	    *error_code = MPI_ERR_UNKNOWN;
+#else
+	    *error_code = MPIR_Err_setmsg(MPI_ERR_IO, MPIR_ADIO_ERROR, myname,
+		"Open Error", "%s", 
+		"Open failed on a remote node");
+	    ADIOI_Error(MPI_FILE_NULL, *error_code, myname);
+#endif
+	}
     }
 
     return fd;
 }
 
 /* a simple linear search. possible enancement: add a my_cb_nodes_index member
  * ( index into cb_nodes, else -1 if not aggregator ) for faster lookups 
  *
@@ -265,10 +293,8 @@
         int i;
         
         for (i=0; i< fd->hints->cb_nodes; i++ ) {
                 if ( rank == fd->hints->ranklist[i] )
                         return 1;
         }
         return 0;
 }
-
-
Index: romio/adio/common/ad_write_str.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/common/ad_write_str.c,v
retrieving revision 1.11
retrieving revision 1.12
--- romio/adio/common/ad_write_str.c	26 Jul 2003 23:16:57 -0000	1.11
+++ romio/adio/common/ad_write_str.c	16 Dec 2003 21:51:22 -0000	1.12
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_write_str.c,v 1.11 2003/07/26 23:16:57 David Exp $    
+ *   $Id: ad_write_str.c,v 1.12 2003/12/16 21:51:22 robl Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "adio.h"
 #include "adio_extern.h"
 
@@ -96,16 +96,31 @@
     int buf_count, buftype_is_contig, filetype_is_contig;
     ADIO_Offset userbuf_off;
     ADIO_Offset off, req_off, disp, end_offset=0, writebuf_off, start_off;
     char *writebuf;
     int flag, st_fwr_size, st_n_filetypes, writebuf_len, write_sz;
     ADIO_Status status1;
     int new_bwr_size, new_fwr_size, max_bufsize;
 
+    if (fd->hints->ds_write == ADIOI_HINT_DISABLE) {
+    	/* if user has disabled data sieving on reads, use naive
+	 * approach instead.
+	 */
+	ADIOI_GEN_WriteStrided_naive(fd, 
+				    buf,
+				    count,
+				    datatype,
+				    file_ptr_type,
+				    offset,
+				    status,
+				    error_code);
+    	return;
+    }
+
     *error_code = MPI_SUCCESS;  /* changed below if error */
 
     ADIOI_Datatype_iscontig(datatype, &buftype_is_contig);
     ADIOI_Datatype_iscontig(fd->filetype, &filetype_is_contig);
 
     MPI_Type_size(fd->filetype, &filetype_size);
     if ( ! filetype_size ) {
 	*error_code = MPI_SUCCESS; 
Index: romio/adio/common/ad_write_str_naive.c
===================================================================
RCS file: romio/adio/common/ad_write_str_naive.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ romio/adio/common/ad_write_str_naive.c	16 Dec 2003 21:51:23 -0000	1.1
@@ -0,0 +1,375 @@
+/* -*- Mode: C; c-basic-offset:4 ; -*- */
+/* 
+ *   $Id: ad_write_str_naive.c,v 1.1 2003/12/16 21:51:23 robl Exp $
+ *
+ *   Copyright (C) 2001 University of Chicago. 
+ *   See COPYRIGHT notice in top-level directory.
+ */
+
+#include "adio.h"
+#include "adio_extern.h"
+
+void ADIOI_GEN_WriteStrided_naive(ADIO_File fd, void *buf, int count,
+                       MPI_Datatype buftype, int file_ptr_type,
+                       ADIO_Offset offset, ADIO_Status *status, int
+                       *error_code)
+{
+    /* offset is in units of etype relative to the filetype. */
+
+    ADIOI_Flatlist_node *flat_buf, *flat_file;
+    /* bwr == buffer write; fwr == file write */
+    int bwr_size, fwr_size=0, b_index;
+    int bufsize, size, sum, n_etypes_in_filetype, size_in_filetype;
+    int n_filetypes, etype_in_filetype;
+    ADIO_Offset abs_off_in_filetype=0;
+    int filetype_size, etype_size, buftype_size, req_len;
+    MPI_Aint filetype_extent, buftype_extent; 
+    int buf_count, buftype_is_contig, filetype_is_contig;
+    ADIO_Offset userbuf_off;
+    ADIO_Offset off, req_off, disp, end_offset=0, start_off;
+    ADIO_Status status1;
+
+    *error_code = MPI_SUCCESS;  /* changed below if error */
+
+    ADIOI_Datatype_iscontig(buftype, &buftype_is_contig);
+    ADIOI_Datatype_iscontig(fd->filetype, &filetype_is_contig);
+
+    MPI_Type_size(fd->filetype, &filetype_size);
+    if ( ! filetype_size ) {
+	*error_code = MPI_SUCCESS; 
+	return;
+    }
+
+    MPI_Type_extent(fd->filetype, &filetype_extent);
+    MPI_Type_size(buftype, &buftype_size);
+    MPI_Type_extent(buftype, &buftype_extent);
+    etype_size = fd->etype_size;
+
+    bufsize = buftype_size * count;
+
+    /* contiguous in buftype and filetype is handled elsewhere */
+
+    if (!buftype_is_contig && filetype_is_contig) {
+    	int b_count;
+	/* noncontiguous in memory, contiguous in file. */
+
+	ADIOI_Flatten_datatype(buftype);
+	flat_buf = ADIOI_Flatlist;
+	while (flat_buf->type != buftype) flat_buf = flat_buf->next;
+
+        off = (file_ptr_type == ADIO_INDIVIDUAL) ? fd->fp_ind : 
+              fd->disp + etype_size * offset;
+
+	start_off = off;
+	end_offset = off + bufsize - 1;
+
+	/* if atomicity is true, lock (exclusive) the region to be accessed */
+        if ((fd->atomicity) && (fd->file_system != ADIO_PIOFS) && 
+	   (fd->file_system != ADIO_PVFS))
+	{
+            ADIOI_WRITE_LOCK(fd, start_off, SEEK_SET, end_offset-start_off+1);
+	}
+
+	/* for each region in the buffer, grab the data and put it in
+	 * place
+	 */
+        for (b_count=0; b_count < count; b_count++) {
+            for (b_index=0; b_index < flat_buf->count; b_index++) {
+                userbuf_off = b_count*buftype_extent + 
+		              flat_buf->indices[b_index];
+		req_off = off;
+		req_len = flat_buf->blocklens[b_index];
+
+		ADIO_WriteContig(fd, 
+				(char *) buf + userbuf_off,
+				req_len, 
+				MPI_BYTE, 
+		    		ADIO_EXPLICIT_OFFSET,
+				req_off,
+				&status1,
+				error_code);
+		if (*error_code != MPI_SUCCESS) return;
+
+		/* off is (potentially) used to save the final offset later */
+                off += flat_buf->blocklens[b_index];
+            }
+	}
+
+        if ((fd->atomicity) && (fd->file_system != ADIO_PIOFS) && 
+	   (fd->file_system != ADIO_PVFS))
+	{
+            ADIOI_UNLOCK(fd, start_off, SEEK_SET, end_offset-start_off+1);
+	}
+
+        if (file_ptr_type == ADIO_INDIVIDUAL) fd->fp_ind = off;
+
+    }
+
+    else {  /* noncontiguous in file */
+    	int f_index, st_fwr_size, st_index = 0, st_n_filetypes;
+	int flag;
+
+        /* First we're going to calculate a set of values for use in all
+	 * the noncontiguous in file cases:
+	 * start_off - starting byte position of data in file
+	 * end_offset - last byte offset to be acessed in the file
+	 * st_n_filetypes - how far into the file we start in terms of
+	 *                  whole filetypes
+	 * st_index - index of block in first filetype that we will be
+	 *            starting in (?)
+	 * st_fwr_size - size of the data in the first filetype block
+	 *               that we will write (accounts for being part-way
+	 *               into writing this block of the filetype
+	 *
+	 */
+
+	/* filetype already flattened in ADIO_Open */
+	flat_file = ADIOI_Flatlist;
+	while (flat_file->type != fd->filetype) flat_file = flat_file->next;
+	disp = fd->disp;
+
+	if (file_ptr_type == ADIO_INDIVIDUAL) {
+	    start_off = fd->fp_ind; /* in bytes */
+	    n_filetypes = -1;
+	    flag = 0;
+	    while (!flag) {
+                n_filetypes++;
+		for (f_index=0; f_index < flat_file->count; f_index++) {
+		    if (disp + flat_file->indices[f_index] + 
+                       (ADIO_Offset) n_filetypes*filetype_extent + 
+		       flat_file->blocklens[f_index] >= start_off) 
+		    {
+		    	/* this block contains our starting position */
+
+			st_index = f_index;
+			fwr_size = (int) (disp + flat_file->indices[f_index] + 
+		 	           (ADIO_Offset) n_filetypes*filetype_extent + 
+				   flat_file->blocklens[f_index] - start_off);
+			flag = 1;
+			break;
+		    }
+		}
+	    }
+	}
+	else {
+	    n_etypes_in_filetype = filetype_size/etype_size;
+	    n_filetypes = (int) (offset / n_etypes_in_filetype);
+	    etype_in_filetype = (int) (offset % n_etypes_in_filetype);
+	    size_in_filetype = etype_in_filetype * etype_size;
+ 
+	    sum = 0;
+	    for (f_index=0; f_index < flat_file->count; f_index++) {
+		sum += flat_file->blocklens[f_index];
+		if (sum > size_in_filetype) {
+		    st_index = f_index;
+		    fwr_size = sum - size_in_filetype;
+		    abs_off_in_filetype = flat_file->indices[f_index] +
+			                  size_in_filetype - 
+			                  (sum - flat_file->blocklens[f_index]);
+		    break;
+		}
+	    }
+
+	    /* abs. offset in bytes in the file */
+	    start_off = disp + (ADIO_Offset) n_filetypes*filetype_extent + 
+	    	        abs_off_in_filetype;
+	}
+
+	st_fwr_size = fwr_size;
+	st_n_filetypes = n_filetypes;
+
+	/* start_off, st_n_filetypes, st_index, and st_fwr_size are 
+	 * all calculated at this point
+	 */
+
+        /* Calculate end_offset, the last byte-offset that will be accessed.
+         * e.g., if start_off=0 and 100 bytes to be written, end_offset=99
+	 */
+	userbuf_off = 0;
+	f_index = st_index;
+	off = start_off;
+	fwr_size = ADIOI_MIN(st_fwr_size, bufsize);
+	while (userbuf_off < bufsize) {
+	    userbuf_off += fwr_size;
+	    end_offset = off + fwr_size - 1;
+
+	    if (f_index < (flat_file->count - 1)) f_index++;
+	    else {
+		f_index = 0;
+		n_filetypes++;
+	    }
+
+	    off = disp + flat_file->indices[f_index] + 
+	          (ADIO_Offset) n_filetypes*filetype_extent;
+	    fwr_size = ADIOI_MIN(flat_file->blocklens[f_index], 
+	                         bufsize-(int)userbuf_off);
+	}
+
+	/* End of calculations.  At this point the following values have
+	 * been calculated and are ready for use:
+	 * - start_off
+	 * - end_offset
+	 * - st_n_filetypes
+	 * - st_index
+	 * - st_fwr_size
+	 */
+
+	/* if atomicity is true, lock (exclusive) the region to be accessed */
+        if ((fd->atomicity) && (fd->file_system != ADIO_PIOFS) && 
+	   (fd->file_system != ADIO_PVFS))
+	{
+            ADIOI_WRITE_LOCK(fd, start_off, SEEK_SET, end_offset-start_off+1);
+	}
+
+	if (buftype_is_contig && !filetype_is_contig) {
+	    /* contiguous in memory, noncontiguous in file. should be the
+	     * most common case.
+	     */
+
+	    userbuf_off = 0;
+	    f_index = st_index;
+	    off = start_off;
+	    n_filetypes = st_n_filetypes;
+	    fwr_size = ADIOI_MIN(st_fwr_size, bufsize);
+
+	    /* while there is still space in the buffer, write more data */
+	    while (userbuf_off < bufsize) {
+                if (fwr_size) { 
+                    /* TYPE_UB and TYPE_LB can result in 
+                       fwr_size = 0. save system call in such cases */ 
+		    req_off = off;
+		    req_len = fwr_size;
+
+		    ADIO_WriteContig(fd, 
+				    (char *) buf + userbuf_off,
+				    req_len, 
+				    MPI_BYTE, 
+				    ADIO_EXPLICIT_OFFSET,
+				    req_off,
+				    &status1,
+				    error_code);
+		    if (*error_code != MPI_SUCCESS) return;
+		}
+		userbuf_off += fwr_size;
+
+                if (off + fwr_size < disp + flat_file->indices[f_index] +
+                   flat_file->blocklens[f_index] + 
+		   (ADIO_Offset) n_filetypes*filetype_extent)
+		{
+		    /* important that this value be correct, as it is
+		     * used to set the offset in the fd near the end of
+		     * this function.
+		     */
+                    off += fwr_size;
+		}
+                /* did not reach end of contiguous block in filetype.
+                 * no more I/O needed. off is incremented by fwr_size.
+		 */
+                else {
+		    if (f_index < (flat_file->count - 1)) f_index++;
+		    else {
+			f_index = 0;
+			n_filetypes++;
+		    }
+		    off = disp + flat_file->indices[f_index] + 
+                          (ADIO_Offset) n_filetypes*filetype_extent;
+		    fwr_size = ADIOI_MIN(flat_file->blocklens[f_index], 
+		                         bufsize-(int)userbuf_off);
+		}
+	    }
+	}
+	else {
+	    int i, tmp_bufsize = 0;
+	    /* noncontiguous in memory as well as in file */
+
+	    ADIOI_Flatten_datatype(buftype);
+	    flat_buf = ADIOI_Flatlist;
+	    while (flat_buf->type != buftype) flat_buf = flat_buf->next;
+
+	    b_index = buf_count = 0;
+	    i = (int) (flat_buf->indices[0]);
+	    f_index = st_index;
+	    off = start_off;
+	    n_filetypes = st_n_filetypes;
+	    fwr_size = st_fwr_size;
+	    bwr_size = flat_buf->blocklens[0];
+
+	    /* while we haven't read size * count bytes, keep going */
+	    while (tmp_bufsize < bufsize) {
+    		int new_bwr_size = bwr_size, new_fwr_size = fwr_size;
+
+		size = ADIOI_MIN(fwr_size, bwr_size);
+		if (size) {
+		    req_off = off;
+		    req_len = size;
+		    userbuf_off = i;
+
+		    ADIO_WriteContig(fd, 
+				    (char *) buf + userbuf_off,
+				    req_len, 
+				    MPI_BYTE, 
+				    ADIO_EXPLICIT_OFFSET,
+				    req_off,
+				    &status1,
+				    error_code);
+		    if (*error_code != MPI_SUCCESS) return;
+		}
+
+		if (size == fwr_size) {
+		    /* reached end of contiguous block in file */
+		    if (f_index < (flat_file->count - 1)) f_index++;
+		    else {
+			f_index = 0;
+			n_filetypes++;
+		    }
+
+		    off = disp + flat_file->indices[f_index] + 
+                          (ADIO_Offset) n_filetypes*filetype_extent;
+
+		    new_fwr_size = flat_file->blocklens[f_index];
+		    if (size != bwr_size) {
+			i += size;
+			new_bwr_size -= size;
+		    }
+		}
+
+		if (size == bwr_size) {
+		    /* reached end of contiguous block in memory */
+
+		    b_index = (b_index + 1)%flat_buf->count;
+		    buf_count++;
+		    i = (int) (buftype_extent*(buf_count/flat_buf->count) +
+			flat_buf->indices[b_index]);
+		    new_bwr_size = flat_buf->blocklens[b_index];
+		    if (size != fwr_size) {
+			off += size;
+			new_fwr_size -= size;
+		    }
+		}
+		tmp_bufsize += size;
+		fwr_size = new_fwr_size;
+                bwr_size = new_bwr_size;
+	    }
+	}
+
+	/* unlock the file region if we locked it */
+        if ((fd->atomicity) && (fd->file_system != ADIO_PIOFS) && 
+	   (fd->file_system != ADIO_PVFS))
+	{
+            ADIOI_UNLOCK(fd, start_off, SEEK_SET, end_offset-start_off+1);
+	}
+
+	if (file_ptr_type == ADIO_INDIVIDUAL) fd->fp_ind = off;
+    } /* end of (else noncontiguous in file) */
+
+    fd->fp_sys_posn = -1;   /* mark it as invalid. */
+
+#ifdef HAVE_STATUS_SET_BYTES
+    MPIR_Status_set_bytes(status, buftype, bufsize);
+    /* This is a temporary way of filling in status. The right way is to 
+     * keep track of how much data was actually written and placed in buf 
+     */
+#endif
+
+    if (!buftype_is_contig) ADIOI_Delete_flattened(buftype);
+}
